filen = "C:\\Users\\Corey\\Desktop\\000.rgm"
-- filen = "C:\\Users\\Corey\\Desktop\\x_mas.rgm"
filen = "C:\\Users\\Corey\\Desktop\\1404.rgm"
--filen = GetOpenFileName caption:"Select any File" types: "All files (*.*)|*.*|"

struct _header (
	filetype="",
	unk1=0,
	unk2=0,
	unk3=[0,0,0],
	unk4=[0,0,0],
	unk5=[0,0,0],
	count1=0,
	unk6=0,
	fn readstream f = (
		local i = 1
		filetype = (
			for i = 1 to 0x1E do (
				filetype+=bit.IntAsChar(readbyte f #unsigned)
				)
			)
		unk1 = readbyte f #unsigned
		if unk1 == 0x00 then (
			unk2 = readbyte f #unsigned
			unk3 = [readbyte f #unsigned / 255.0,readbyte f #unsigned / 255.0,readbyte f #unsigned / 255.0]
			unk4 = [readbyte f #unsigned / 255.0,readbyte f #unsigned / 255.0,readbyte f #unsigned / 255.0]
			unk5 = [readbyte f #unsigned / 255.0,readbyte f #unsigned / 255.0,readbyte f #unsigned / 255.0]
			
			for i = 1 to 32 do (
				format "::\t%\t%\n" (readstring f) (readbyte f #unsigned)
				)
			
			count1=readlong f #unsigned
			unk6=readlong f #unsigned
			)
		else (
			format "Wrong File Type\n"
			)
		)
	)
struct _subHeader2 (
	unk01=0,
	unk02=0,
	unk03=0,
	unk04=0,
	unk05=(matrix3 1),
	unk17=0,
	unk18=0,
	fn readstream f = (
		unk01=readbyte f #unsigned
		unk02=readshort f #unsigned
		unk03=readshort f #unsigned
		unk05.row1=[readfloat f,readfloat f,readfloat f]
		unk05.row2=[readfloat f,readfloat f,readfloat f]
		unk05.row3=[readfloat f,readfloat f,readfloat f]
		unk05.row4=[readfloat f,readfloat f,readfloat f]
		unk17=readlong f #unsigned
		unk18=readbyte f #unsigned
		)
	)
struct _table2 (
	unk01=(matrix3 1),
	fn readstream f = (
		unk01.row1 = [readfloat f,readfloat f,readfloat f]
		unk01.row2 = [readfloat f,readfloat f,readfloat f]
		unk01.row3 = [readfloat f,readfloat f,readfloat f]
		unk01.row4 = [readfloat f,readfloat f,readfloat f]
		)
	)
struct _table3 ( -- position
	unk01=[0,0,0],
	unk02=[0,0,0],
	unk03=[0,0,0],
	fn readstream f = (
		unk01 = [readfloat f,readfloat f,readfloat f]
		unk02 = [readfloat f,readfloat f,readfloat f]
		unk03 = [readfloat f,readfloat f,0]
		)
	)
struct _table4 (
	unk1="",
	unk2=0,
	fn readstream f = (
		local p = ftell f + 0x28
		unk1 = readstring f
		fseek f p #seek_set
		unk2 = readbyte f #unsigned
		)
	)
fn buildObj verts tverts faces = (
	local j,msh
	if verts.count>0 do (
		msh = mesh vertices:verts tverts:tverts faces:faces
		msh.numTVerts = tverts.count
		msh.displayByLayer = false
		msh.backfacecull = on
		buildTVFaces msh
		for j = 1 to tverts.count do setTVert msh j tverts[j]
		for j = 1 to faces.count do setTVFace msh j faces[j]
		)
	msh
	)
fn readmyfile filen = (
	local f,i=1,ii=1
	local hdr=_header()
	local shdr2=_subHeader2()
	local tlb2=_table2()
	local tlb3 = _table3()
	local tlb4 = _table4()
	local face=[1,2,3]
	local vertArray = #()
	local tvertArray = #()
	local faceArray = #()
	if filen!=undefined do (
		f = fopen filen "rb"
		hdr.readstream(f)
		
		for ii =  1 to 1 do (
			shdr2.readstream(f)
			if shdr2.unk17 > 0 then ( -- Vertex Positions, Normals, UV's
				for i = 1 to shdr2.unk17 do (
					tlb3.readstream(f)
					append vertArray tlb3.unk01
					append tvertArray [tlb3.unk03[1],tlb3.unk03[2],0]
					)
				for i = 1 to (readlong f #unsigned) do ( -- Faces, Surfaces, Polygons, Indices
					face = [readshort f #unsigned,readshort f #unsigned,readshort f #unsigned] + 1
					append faceArray face
					)
				for i = 1 to (readlong f #unsigned) do ( -- textures?
					tlb4.readstream(f)
					)
				buildObj vertArray tvertArray faceArray
				)
-- 			for i = 1 to hdr.count1 do (
-- 				tlb2.readstream(f)
-- 				)
				
			)
		format "Last Read @ 0x%\n" (bit.intAsHex((ftell f)as integer))
		fclose f
		)
	)

clearlistener()
readmyfile(filen)